-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
M.vehIn = {}
local settings = {}
local function driveTrainCallback(data)
	gdscenarios.driveTrain = data
end
local function driveTrain()
	if be:getPlayerVehicle(0) then
		local veh = scenetree.findObjectById(be:getPlayerVehicle(0):getID())
		local command = "obj:queueGameEngineLua(string.format('gdcallback.driveTrainCallback(%s)',serialize({gear = drivetrain.gear})))"
		if veh then
			veh:queueLuaCommand(command)
		end
	end
end
local function request(vid)
	M.vehIn = gdscenarios.vehIn
	local veh = scenetree.findObjectById(vid)
	if veh then
		veh:queueLuaCommand('gdcallback.vehInCallBack(' .. serialize(M.vehIn) .. ')')
	end
end
local function getDesc()
	local map = getMissionFilename():match('levels/([%w|_|%-|%s]+)/')
	if map == gdscenarios.oldScenario.map then
		local data = gdscenarios.oldScenario
		return data
	else
		local scenario = scenario_scenarios.getScenario()
		local name = string.find(scenario.name,'Demolition Derby')
		local found = 1
		if name then
			found = 2
		end
		local data = {name=scenario.name, desc = scenario.description, map = map, found=found}
		gdscenarios.oldScenario = data
		--dump(data)
		--print('newmap')
		return data
	end
end
local function getData(selectedMap)
	local data = {}
	local level = core_levels.getSimpleList()
	--dump(levels)
	local scenario = scenario_scenarios.getScenario()
	local map = getMissionFilename():match('levels/([%w|_|%-|%s]+)/')
	if map == nil then
		map = core_levels.getLevelName(getMissionFilename())
	end
	--if scenario.scenarioName ~= 'gdcommon' then
		--if not tracks[map] then
		--This gets tracks from a custom map 
		
	local flevels = {}  --formated map names with original names in a table
	local levels = {}
	for i,v in ipairs(level) do   --go through a list of all the maps in the game
		if v == 'gdcommon' then
			table.remove(level, i)
		else
			local str = v:upper()
			str = str:gsub("[%c%p%s]", " ")
			flevels[str] = v           -- create a table with the map name in caps and equal the map name without caps.
			table.insert(levels, str)  -- build a table of all the map names in all caps 
		end
	end
	if selectedMap then 
		local mtrack = flevels[selectedMap]
		if mtrack then 
			local fp = 'levels/'..mtrack..'/scenarios/tracks.json'
			if FS:fileExists(fp) then
				local file = readJsonFile(fp)
				if file then
					data['tracks'] =  file
				end
			end
		end
	end
	
		--data['levels'] = levels
		--data['flevels'] = flevels
		--data['map'] = map:upper():gsub("[%c%p%s]", " ")
		data['model'], data['config2'], data['group'] = scenario_gdclasses.modelName()
	return data
end
local function getConfigs(selected)
	local options = selected.options
	gdscenarios.selection(options)
	local data = {}
	local mtrack = options.level
	if mtrack then
		local fp =  mtrack..'/scenarios/tracks.json'
		print(fp)
		if not mtrack then
			mtrack = options.map
			fp = 'levels/'..mtrack..'/scenarios/tracks.json'
		end
		if FS:fileExists(fp) then
			local file = readJsonFile(fp)
			if file then
				data['tracks'] =  file
			end
		end
	end
	--data['player'] = options.oppKey;
		--data['vehicles'], data['config2']= scenario_gdclasses.modelName()
	return data
end
local function getTracks()
	local data = {}
	local files = M.getLevelList()
	for _, levelName in ipairs(files) do
		local fp = 'levels/'..levelName..'/scenarios/tracks.json'
		if FS:fileExists(fp) then
			local file = readJsonFile(fp)
			if file then
				if not data[levelName] then
					data[levelName] = {}
				end
				data[levelName] = file
			end
		end
	end
	return data
end
local function getParts()
	local data = {}
	data['parts'] = scenario_gdclasses.getParts()
	return data
end
--[[
local function saveObject(key,value)
	local fn = string.format('settings/derbyMenu.json')
	local file = {}
	if FS:fileExists(fn) then
		file = readJsonFile(fn)
	end
	file[key] = value
	serializeJsonToFile(fn, file, true)
	print('saving object file')
	gdscenarios.selection(file)
end
local function saveTable(file)
	local fn = string.format('settings/derbyMenu.json')
	if file then
		serializeJsonToFile(fn, file, true)
		gdscenarios.selection(file)
	end
end
local function getSavedSelections()
	local fn = string.format('settings/derbyMenu.json')
	if FS:fileExists(fn) then
		local file = readJsonFile(fn)
		if file then
			settings = file
			return settings
		else
			return nil
		end
	end
end
local function removeItem(key, menu)
	local fn = string.format('settings/derbyMenu.json')
	if FS:fileExists(fn) then
		local file = readJsonFile(fn)
		if file then
			if menu then
				file[menu][key] = {}
			else
				file[key] = {}
			end
		end
		serializeJsonToFile(fn, file, true)
	end
end
local function clearAll()
	local fn = string.format('settings/derbyMenu.json')
	local file = {}
	serializeJsonToFile(fn, file, true)
end
--]]
local function getLevelList()
  if not FS:directoryExists('levels/') then
    return {}
  end
  local files = FS:findFiles('/levels/', 'info.json', 1, true, false)
  -- filter paths to only return filename without extension
  for k,v in pairs(files) do
    files[k] = string.gsub(files[k], "(.*/)(.*)/(.*)", "%2")
  end
  return files
end
--[[
-- this function parses the quickrace files, and returns a list of all tracks for one level.
local function getTracks2(gdFiles, levelName, lvlName)
  local tracks = {}
  local procedurals = lvlName == "driver_training"
  for _, trackFile in ipairs(gdFiles) do
    local dir, filename, ext = path.split(trackFile, true)
    if ext == 'json' or ext == 'race.json' then
      local file = jsonReadFile(trackFile)
      if not file then
        log('E', 'failed to load this track ' , tostring(trackFile).. ' Check Json file')
      elseif procedurals ~= not file.procedural then -- no this cannot be changed to procedurals == file.procedural, becaus then false == nil -> false
        file.originalInfo = deepcopy(file)
        file.sourceFile = trackFile
        local dir, filename, ext = path.splitWithoutExt(trackFile, true)
        file.trackName = filename
        file.directory = dir
        --file.raceFile = "/levels/"..levelName.."/quickrace/"..file.trackName..'.json'
        file.difficulty = file.difficulty and tonumber(file.difficulty) or nil
        --file.prefabs = file.prefabs or {}
        --file.reversePrefabs = file.reversePrefabs or {}
        --file.forwardPrefabs = file.forwardPrefabs or {}
        --file.customMarker = 'default'
        file.raceFile = ext == 'race.json' and trackFile or nil--FS:findFilesByRootPattern(file.directory, file.trackName..'.race.json', 0, true, false)
        local officialPath = trackFile
        file.official = FS:fileExists(officialPath) and isOfficialContentVPath(officialPath)

        if file.luaFile then
          file.luaFile = "/levels/"..levelName.."/"..file.luaFile
        else
          file.luaFile = nil
        end

        if file.procedural then
          file.customData.seed = math.random(500*500*500*500)
        end

        -- find preview for forward and reverse
        local tmp = FS:findFiles(file.directory, file.trackName..'.jpg', 0, true, false)
        file.previews = {}
        for _, p in pairs(tmp) do
          table.insert(file.previews, p)
        end

        local tmp = FS:findFiles(file.directory, file.trackName..'_reverse.jpg', 0, true, false)
        file.reversePreviews = {}
        for _, p in pairs(tmp) do
          table.insert(file.reversePreviews, p)
        end


        -- set spawnSpheres.
        if not file.spawnSpheres then
          file.spawnSpheres = {}
        end

        if not file.closed then
          file.lapCount = 1
        end

        file.lapCount = file.lapCount or 1

        file.spawnSpheres.standing = file.spawnSpheres.standing or file.trackName.."_standing_spawn"
        file.spawnSpheres.standingReverse = file.spawnSpheres.standingReverse or file.trackName.."_standingReverse_spawn"
        file.spawnSpheres.rolling = file.spawnSpheres.rolling or file.trackName.."_rolling_spawn"
        file.spawnSpheres.rollingReverse = file.spawnSpheres.rollingReverse or file.trackName.."_rollingReverse_spawn"

        file.tod = file.tod or 3

        -- figure out if a html start file is existing
        --local htmldiscovered = false
        --if not file.startHTML then
         -- file.startHTML = "quickrace/"..file.trackName .. '.html'
         -- htmldiscovered = true
        --end
        --if not FS:fileExists("/levels/"..levelName..'/'..file.startHTML) then
         -- if not htmldiscovered then
            --log('W', 'scenarios', 'start html not found, disabled: ' .. file.startHTML)
          --end
          --file.startHTML = nil
          --file.introType = 'none'
        --end

        --if not file.introType then
         -- file.introType = 'htmlOnly'
       -- end

        if file.raceFile  then
          if file.classification then
            file.lapCount = file.defaultLaps
            file.closed = file.classification.closed
            file.allowRollingStart = file.classification.allowRollingStart
            file.reversible = file.classification.reversible
          end
          file.lapConfig = {}
          file.startLineCheckpoint = ''
        end
        table.insert(tracks, file)
      end
    end
  end
  table.sort(tracks, function(a,b) return a.name < b.name end)
  return tracks
end
-- loads the previews for the levels. This code is copied and slightly modified from the scenario_scenarios.lua ...
local function  customPreviewLoader( levelInfo, levelName)
  -- figure out the previews automatically and check for errors

  levelInfo.directory = '/levels/'..levelName
  levelInfo.previews = {}

  if type(levelInfo.levelInfo.previews) == 'table' and #levelInfo.levelInfo.previews > 0 then
    -- add prefix
    local newPreviews = {}
    for _, img in pairs(levelInfo.levelInfo.previews) do
      table.insert(newPreviews, levelInfo.directory..'/' .. img)
    end
    levelInfo.previews = newPreviews
  else
    local tmp = FS:findFiles("/levels/"..levelName.."/",levelName..'_preview*.png', 0, true, false)
    for _, p in pairs(tmp) do
      table.insert(levelInfo.previews, p)
    end
    tmp = FS:findFiles("/levels/"..levelName.."/",levelName..'_preview*.jpg', 0, true, false)
    for _, p in pairs(tmp) do
      table.insert(levelInfo.previews, p)
    end
  end
  if #levelInfo.previews == 0 then
    log('W', 'scenarios', 'scenario has no previews: ' .. tostring(levelInfo.scenarioName))
  end
  return levelInfo.previews
end
local function gdLevelList()
  local files = M.getLevelList()

  local proceduralLevel = {}
  local levels = {}
  local addingProcedural = true

 --dump(files)
  for _, levelName in ipairs(files) do
    --print(levelName)
    local path = '/levels/' .. levelName
    local gdFiles =  FS:findFiles(path, '*.json', -1, true, false)
      local newLevel = {}
      newLevel.levelName = levelName
      newLevel.levelInfo =  jsonReadFile('/levels/'..levelName..'/info.json') -- this contains the level info for the UI!

      newLevel.official = isOfficialContentVPath('levels/'..levelName..'/info.json')
      if not newLevel.levelInfo then
        log('W', 'gdScenarios', 'could not load info-file for Level ' .. levelName)
      else
        newLevel.name = newLevel.levelInfo.title
      end

      newLevel.scenarioName = newLevel.name

      newLevel.previews = M.customPreviewLoader(newLevel, levelName)
    
      newLevel.mission = 'levels/'..levelName..'/main.level.json'
	  
      --newLevel.tracks = M.getTracks(gdFiles, levelName, newLevel.levelName)

    --  newLevel.trackCount = #newLevel.tracks

      --if #newLevel.tracks > 0 then
        --if newLevel.previews and #newLevel.previews > 0 then
        --  newLevel.preview = newLevel.previews[1]
       ---   newLevel.preImgIndex = 0
       -- end


        table.insert(levels, newLevel)
      --end
    --  if addingProcedural then
   --     addingProcedural = false
    --  end
    end
    
	print('levels test gdcallback')
  return levels
end--]]


M.getConfigs = getConfigs
M.gdLevelList = gdLevelList
M.getLevelList = getLevelList
M.customPreviewLoader = customPreviewLoader
M.getTracks = getTracks
M.getDesc = getDesc
M.getData = getData
M.saveTable = saveTable
M.clearAll = clearAll
M.saveObject = saveObject
M.getSavedSelections = getSavedSelections
M.removeItem = removeItem
M.getParts = getParts
M.driveTrain = driveTrain
M.driveTrainCallback = driveTrainCallback
M.request = request
return M
