
var app = angular.module('derbyMain', ['ui.router'])

app.run( function() {
  console.log('New Derby App Started');
});

app.config([
    '$stateProvider',
    '$urlRouterProvider',
    function ($stateProvider, $urlRouterProvider) {
      $stateProvider
      .state('gdEndScreen', {
        url: '/gdEndScreen/end',
		 params: {
			endData: {},
			drivers: {},
			headers: {},
		},	
		templateUrl: 'modules/gdcommon/gdEndScreen/end.html',
        controller: 'gdEndController',
		backState: 'BACK_TO_MENU',
      })
	   .state('gdscenario-end', {
        url: '/gdEndScreen/end',
		 params: {
			endData: {},
			drivers: {},
			headers: {},
		},	
		templateUrl: 'modules/gdcommon/gdEndScreen/end.html',
        controller: 'gdEndController',
		backState: 'BACK_TO_MENU',
      })
	  .state('loading-gd',{
		  url: '/gdloading',
		  templateUrl: 'modules/gdcommon/gdStartScreen/gdloading.html',
		  backState: 'BLOCK',
	  })
	 .state('scenario-gdstart', {
		url: '/gdStartScreen/gdstart',
		params: {
		data: {}
		},
		templateUrl: 'modules/gdcommon/gdStartScreen/gdstart.html',
		 backState: 'BACK_TO_MENU',
	  })
	  .state('gdStartScreen', {
      url: '/gdStartScreen/gdstart',
      templateUrl: 'modules/gdcommon/gdStartScreen/gdstart.html',
	   backState: 'BACK_TO_MENU',
    })
	  .state('gdMapSelect', {
      url: '/gdcommon/level',
      templateUrl: 'modules/gdcommon/gdLevelSelect/levelSelect.html',
      controller: 'gdLevelController',
    })
	.state('levels', {
      url: '/levels',
      templateUrl: 'modules/gdcommon/gdLevelSelect/levelselect.html',
      controller:  'LevelSelectController as levels',
    })
	.state('gdlevelDetails', {
      url: '/levels-details/:level/:spawnPoint',
      templateUrl: 'modules/gdcommon/gdLevelSelect/levelselect-details.html',
      controller:  'LevelSelectDetailsController as levelsDetails',
    })
	  $urlRouterProvider.otherwise('/gdStartScreen/gdstart');
    },
]);


/**
  Future how to use:
  Call quickRaceLoader.getQuickraceList(), which contanis a list of levels.
  Each level has a levelInfo-property, which is the info from the info.json in the level.
  Also, each level has a tracks-property list, which contains all the tracks.
  After getting these, display them and let the user select them. Use the QuickraceService
  if you want to, it works for now. Let the user select a vehicle. I copied and modified
  some code of the vehicleselect-screen.
  Once you have a level, track and vehicle, call quickRaceLoader.startQuickrace(level, track, vehicle).
  This will merge the data and create one scenario file, which is then loaded by
  the scenario_scenarios.lua code.
**/



app.factory('gdSelectionsService' , function() {
  var selections= {};

  function set () {
	
	selections.levels = [];
    selections.level = 
	{
      name: '',
      file:null,
      preview: '/ui/images/appDefault.png',
      targetState:'gdMapSelect'
    };
    selections.track = {
      name: '',
      file:null,
      preview: '/ui/images/appDefault.png',
      targetState:'gdTrackselect',
      disabled: true
    };
    selections.vehicle = {
      name: '',
      file:null,
      preview: '/ui/images/appDefault.png',
      targetState: {state: 'vehicles', args: {mode: 'quickrace'}}
    };
  }

  //set();

  return {
    getSelections: function () 		{return selections;		},
    setLevel:       function(level)   { selections.level  = level;  },
    setTrack:       function(track)   { selections.track    = track;  },
    setVehicle:    function(vehicle)  { selections.vehicle   = vehicle; },
	setLevels: 	   function(levels)   {selections.levels = levels	},
    set : set,
    accessibility: function () {
      for (var key in selections) {
        selections[key].disabled = key === 'track';
      }
    }
  };
});
app.controller('gdTabsController', ['LocalStorage','$scope', function (LocalStorage,$scope) {
	'use strict';
	var vm = this;
	vm.parts = {};
	
	vm.tabItems = [
			{'name': 'Main', 'layout': 'start start', 'icon':'home'},
			{'name': 'Opponents','layout':'start start', 'icon':'group'},
			{'name':'Settings', 'layout':'center start', 'icon':'settings'},
			{'name':'Parts', 'layout':'end start', 'icon':'add_circle_outline'}
			];
	vm.activeTab = vm.tabItems[0].name;
    vm.setTab = function(newTab) {
		vm.activeTab = newTab;
		if (vm.activeTab === 'Main'){
			$scope.oppKey = null;
			LocalStorage.setObject('oppKey',$scope.oppKey);
		}
		if (vm.activeTab === 'Opponents'){
			$scope.oppKey = '1';
			LocalStorage.setObject('oppKey',$scope.oppKey);
		}
		if (vm.activeTab === 'Parts') {
		  bngApi.engineLua('gdcallback.getParts()',function (response) {
			$scope.$evalAsync(function () {
				var errors = response.parts[0].msg;1	
				vm.parts = {};				
			if (errors) {
				
				vm.parts.partsGroup = errors;
			}else{
				var partsGroup = response.parts[0].partsGroup;
				var partsMap = response.parts[0].partsMap;
				var slotType = response.parts[0].slotType;
				vm.parts.partsGroup = partsGroup;
				vm.parts.partsMap = partsMap;
				vm.parts.slotType = slotType;
			};
			});
		});
	  }
    };
}]);
app.directive('gdTabs',  function() {
	return{
		restrict: 'EA',
		translate: true,
		templateUrl: "modules/gdcommon/gdStartScreen/gdtabs.html"
		
	};
});
app.controller('gdHeaderController', ['gdSelectionsService','$scope',function(gdSelectionsService,$scope) {
	'use strict';
	var vm = this;
	vm.heading = {};
	
	var filler = document.getElementsByClassName('filler')[0].style
	filler.backgroundImage = "radial-gradient(white 40%, black 70%),url('modules/gdcommon/gdcommonbg.jpg')";
	filler.backgroundSize = "100%";
	filler.backgroundRepeat = "no-repeat";
	filler.backgroundPosition = "center";
	filler.backgroundBlendMode = "multiply";
	
	bngApi.engineLua('gdcallback.getDesc()',function (header) {
		if (header) {
			console.log(header.name);
			vm.heading = header;
		}else{
			vm.heading.name = "Demolition Derby - The Fair Grounds v11.0.0";
			vm.heading.desc = "Race'em or Wreck'em";
		}
	});
		
}]);
app.directive('gdCardVehicles', ['LocalStorage', function(LocalStorage) {
  return {
    restrict: 'E',
	 replace: true,
    template: ` <div class="darkbg" layout="column" layout-align="start start" style="overflow: visible; position: fixed; height: 6vh; width: -webkit-fill-available; top: 0;">
		<md-list layout="row" style="width: -webkit-fill-available;">
			<md-list-item>
					<div style="text-transform: capitalize; align-items: center; font-size: 2vh;" class="color1">{{card.type}}</div>
			</md-list-item>
			<md-list-item   style="position: absolute; right:0; margin:0; align-items: center;">
				<md-button bng-nav-item focus-on-hover class="cardBtnUp" style=" min-width:auto; position:relative;" ng-click="vehMove('down')" >
				<md-icon class="material-icons color1" style="margin: 0 2px;">expand_more</md-icon></md-button>
				<md-button bng-nav-item focus-on-hover class="cardBtnDown" style=" min-width:auto; position:relative;" ng-click="vehMove('up')" >
				<md-icon class="material-icons color1" style="margin: 0 2px;">expand_less</md-icon></md-button>
			</md-list-item>
		</md-list>
	</div>
	`,
	link: function (scope){
		scope.vehMove = function(direction){
			let menuName = scope.card.alt;
			if (menuName === 'vehicles') {
				console.log(scope.card);
				list = scope.card.groups
				type = scope.card.type
				
				let records = list.length;
				let i = list.findIndex(x => x === type);
				if (direction === 'up') {
					i = i + 1;
					if (i === records) {i=0};
				}else if(direction === 'down') {
					i = i - 1;
					if (i < 0) {i = records - 1};
				}
				scope.card.type = list[i];
				scope.card.selected = scope.card.default.name;
				scope.card.url = scope.card.default.url;
				if(!scope.card.url){
					scope.card.url = 'modules/gdcommon/gdImages/noimage.jpg';
				}
				let savedMenu = {};
				savedMenu.selected = scope.card.selected;
				savedMenu.type = scope.card.type;
				savedMenu.url = scope.card.url;
				if (scope.oppKey) {
					LocalStorage.setObject('oppKey',scope.oppKey);
					LocalStorage.setObject(scope.oppKey + menuName, savedMenu);
				}else{
					LocalStorage.setObject(menuName,savedMenu);
				}
				let refresh = {tables : ['vehicles'], oppKey : scope.oppKey}
				scope.$emit('gdConfig', refresh);
			}
		}
	}
  };
}]);
app.directive('gdCardRacing', ['LocalStorage', function(LocalStorage) {
  return {
    restrict: 'E',
	 replace: true,
    template: ` <div class="darkbg" layout="column" layout-align="start start" style="overflow: visible; position: fixed; height: 6vh; width: -webkit-fill-available; top: 0;">
		<md-list layout="row" style="width: -webkit-fill-available;">
			<md-list-item>
				<md-icon   style="position: absolute; right: 90%; margin:0; align-items: center;" class="material-icons color1" >flag</md-icon>
					<div style="position: absolute; right: 75%; align-items: center; font-size: 2vh;" class="color1">{{card.type}}</div>
			</md-list-item>
			<md-list-item  ng-if="card.type === 'Racing'"  style="position: absolute; right: 50%; padding: 1%; align-items: center;">
					<div style="font-size: 2vh;">Laps</div>
			</md-list-item>
			<md-list-item ng-if="card.type === 'Racing'" style="position: absolute; right: 30%; align-items: center;">
					<div ng-if="card.type === 'Racing'" style="align-items: center; font-size: 2vh; font-style: italic; font-weight: bolder;">{{ card.laps }}</div>
			</md-list-item>
			<md-list-item  ng-if="card.type === 'Racing'"   style="position: absolute; right:0; margin:0; align-items: center;">
				<md-button bng-nav-item focus-on-hover class="cardBtnUp" style=" min-width:auto; position:relative;" ng-click="lapMove('down')" >
				<md-icon class="material-icons color1" style="margin: 0 2px;">expand_more</md-icon></md-button>
				<md-button bng-nav-item focus-on-hover class="cardBtnDown" style=" min-width:auto; position:relative;" ng-click="lapMove('up')" >
				<md-icon class="material-icons color1" style="margin: 0 2px;">expand_less</md-icon></md-button>
			</md-list-item>
		</md-list>
	</div>
	`,
	scope:{
		card: '=',
    },
	link: function (scope){
		scope.lapMove = function(direction){
			let menuName = scope.card.alt;
			if (scope.card.laps) {
					if(direction === 'up') {
						scope.card.laps++;
						if(scope.card.laps > 999) {
							scope.card.laps = 999;
						}
					}else if (direction === 'down'){
						scope.card.laps--;
						if (scope.card.laps < 1){
							scope.card.laps = 1;
						}
					}
				LocalStorage.setObject('laps',scope.card.laps);
			}
		}
	}
  };
}]);
app.directive('gdCard',  ['gdMenuService','LocalStorage' , function (gdMenuService,LocalStorage) {
  return {
    restrict: 'E',
	  replace: true,
    templateUrl: 'modules/gdcommon/gdCards/card.html',
   
    link: function (scope) {
	
		//console.log('gdCard link function')
		let levelData = gdMenuService.getLevels();
		 scope.cardMove = function(direction,okey){
			
			let menuName = scope.card.alt;
			let list = []
			let cardName;
			
			if(scope.card.listob) {
				list = scope.card.listob;
				cardName = scope.card.selected
			}
			if (scope.card.listng) {
				list = scope.card.listng;
				cardName = scope.card.selected
			}
	
			if (menuName === 'map'){
					let level = levelData[levelData.findIndex((x) => x.title === scope.card.selected)];
					cardName = level.title;
					levelData.sort((x,y) => x.levelName.localeCompare(y.levelName));	
			
					levelData.forEach((value,key) => {
						if (value.title && value.title !== 'gdcommon'){
							list.push(value.title);
						}
					})
			}else if (menuName === 'tracks' || menuName === 'vehicles'){
				if (scope.card.listg) {
					scope.card.listg.forEach((value,key) => {
					if (value.name){
						list.push(value.name);
						}
					})
					cardName = scope.card.selected;
				}
			}
			
			//console.log(list)
			let records = list.length;
			let i = list.findIndex(x => x === cardName);
			if (direction === 'right') {
				i = i + 1;
				if (i === records) {i=0};
			}else if(direction === 'left') {
				i = i - 1;
				if (i < 0) {i = records - 1};
			}
     
			if (menuName === 'map'){
					let level = levelData[levelData.findIndex((x) => x.title === list[i])];
					if(level && level.title ) {
						if(level.previews.length > 0) {
							scope.card.url = level.previews[Math.floor(Math.random() * level.previews.length)];
						}
						scope.card.selected = level.title;
						LocalStorage.setObject('map',level.levelName);
						LocalStorage.setObject('level',level.misFilePath);
					//console.log(level);
						
					}
			}else if (menuName === 'tracks' || menuName === 'vehicles'){
						scope.card.selected = 'Auto Select' 
						if (scope.card.listg[i].name){
							scope.card.selected = scope.card.listg[i].name;
						}
						scope.card.url = 'modules/gdcommon/gdImages/noimage.jpg';
						if (menuName === 'tracks'){
							scope.card.type = scope.card.listg[i].type;
							if (scope.card.selected !== 'Custom'){
								scope.card.url = scope.card.listg[i].url;
							}
						}else{
							if (scope.card.listg[i].preview){
								scope.card.url = scope.card.listg[i].preview;
							}
						}
						 let savedMenu = {};
						savedMenu.selected = scope.card.selected;
						savedMenu.type = scope.card.type;
						savedMenu.url = scope.card.url;
						//console.log(scope.card)
					
						if (scope.oppKey) {
							LocalStorage.setObject('oppKey',scope.oppKey);
							LocalStorage.setObject(scope.oppKey + menuName, savedMenu);
						}else{
							LocalStorage.setObject(menuName,savedMenu);
						}
			}else{
				scope.card.selected = list[i];
				scope.card.url = 'modules/gdcommon/gdImages/' + menuName + '/' + scope.card.selected + '.jpg';
				console.log(scope.card)
				if (scope.oppKey) {
					LocalStorage.setObject('oppKey',scope.oppKey);
					LocalStorage.setObject(scope.oppKey + menuName,list[i]);
				}else{
					LocalStorage.setObject(menuName,list[i]);
				}
			}
			
			//gdMenuService.saveMenus();
		
			//if (scope.card.refresh === 1 ) {
					//if (scope.card.alt !== 'config2') {

						if (scope.card.refresh && scope.card.refresh !== 'undefined'){
							if (scope.card.refresh[0] === 'tracks'){
								gdMenuService.setTracks();
							}
							 gdMenuService.setConfigs(scope.oppKey);
							 //if (scope.oppKey){
								// scope.oppKey = '0';
							 //}
							 let refresh = {tables : scope.card.refresh, oppKey : scope.oppKey};
								scope.$emit('gdConfig', refresh);
						};
				
					
					//}
			//}else if (scope.card.refresh === 2 ) {
			//	scope.$emit('gdConfig');
			//}

		};
		
		scope.$on('$destroy', function() {
		});
	}
  }
}]);
app.directive('derbyPartsTab', function() {
  return {
    restrict: 'E',
	replace: true,
    templateUrl: 'modules/gdcommon/gdTabs/parts.html',
  };
});
app.directive('derbySettingsTab', ['LocalStorage' , function (LocalStorage) { 
  return {
    restrict: 'E',
    templateUrl: 'modules/gdcommon/gdTabs/settings.html',
    scope: {
      settings: '=',
    },
	link: function (scope) {
	
	scope.loadTip = function (data){
		scope.settingsTip = data;
	}
	scope.update =  function(name,value){
		//console.log('save update Setting');
		//console.log(name);
		//console.log(value);
		LocalStorage.setObject(name,value);
		//gdMenuService.saveMenus();
	}

	},
  };
}]);	

app.directive('derbyOpponentsTab', function() {
  return {
    restrict: 'E',
    templateUrl: 'modules/gdcommon/gdTabs/opponents.html',
   
	link: function (scope) {
	scope.loadCard =  function(key, group){
		scope.oppKey = key;
		//scope.oppCard = group;
	}

	},
  };
});
app.directive('derbyMainTab', function() {
  return {
    restrict: 'E',
    templateUrl: 'modules/gdcommon/gdTabs/main.html',
  };
});	
app.factory('gdCardService', ['gdMenuService','LocalStorage',function(gdMenuService, LocalStorage){
	
	
	let cards = {};
	let levelData = [];
	let opponents = [];
	let trackData = {};
	
	function init () {

		levelData = gdMenuService.getLevels();
		gdMenuService.getTracks().then(function(tData){
			trackData = tData;
		})
	}
	function setup (menu, trackMenu, vconfig, oppKey) {
		let menuName = menu.alt;
		//if (refresh && refresh === menuName || !refresh){
		if (!cards || !cards[menuName] ) {
			cards[menuName] = {};
			cards[menuName] = menu;
		}
		if(!oppKey){
			oppKey = 0;
		}
		let savedMenu = LocalStorage.getObject(menuName);
		if (oppKey && oppKey > 0){
			savedMenu = LocalStorage.getObject(oppKey + menuName);
		}
	
		//if config 2 is not found in the listob table then reset to defaults
		if(vconfig && vconfig[0]){
			cards[menuName].default = vconfig[0].default;
			cards[menuName].listob = vconfig[0].listob;
				if(cards[menuName].listob[0]){
					if (savedMenu){ 
						let indexFound = cards[menuName].listob.findIndex(x => x === savedMenu );
						if (indexFound === -1 || indexFound === 'undefined'){
							savedMenu = cards[menuName].default;
						}
					}
				}else{
					return;
				}
		}
		if (savedMenu ){
			if (savedMenu.selected){
				cards[menuName].selected  = savedMenu.selected;
				cards[menuName].type = savedMenu.type;
				if (savedMenu.url){
					cards[menuName].url = savedMenu.url;
				}else{
					cards[menuName].url = 'modules/gdcommon/gdImages/noimage.jpg';
				}
			}else{
				cards[menuName].selected = savedMenu;
				cards[menuName].url = 'modules/gdcommon/gdImages/' + menuName + '/' + savedMenu + '.jpg';
			}
		}else{
			
			savedMenu = cards[menuName].default;
			if (cards[menuName].default.name){
				if (cards[menuName].default.type) {
					cards[menuName].type = cards[menuName].default.type;
				};
				cards[menuName].url = 'modules/gdcommon/gdImages/' + menuName  + '/' + cards[menuName].default.name + '.jpg';
				cards[menuName].selected = cards[menuName].default.name;
			}else{
				cards[menuName].url = 'modules/gdcommon/gdImages/' + menuName + '/' + cards[menuName].default + '.jpg';
				cards[menuName].selected = cards[menuName].default;
			}
		
		}		
		if(menuName === 'map'){
			let level = levelData[levelData.findIndex((x) => x.levelName === cards[menuName].selected)];
			if(level && level.title ) {
				if(level.previews.length > 0) {
					cards[menuName].url = level.previews[Math.floor(Math.random() * level.previews.length)];
				}
				cards[menuName].selected = level.title;
				savedMenu = level.levelName;
				LocalStorage.setObject('level',level.misFilePath);		
			}
		}
							
		if (menuName === 'tracks') {
							//console.log(menu);
			let levelName = LocalStorage.getObject('map');  //get current map
			let tracksList = trackMenu;  //get a list of tracks
			let tracks;
			if (levelName && tracksList) {
				tracks = tracksList[levelName];//derby is grass 
				//console.log(trackData);
				if ( trackData && trackData[levelName] && trackData[levelName].arenas){
					let customTracks = trackData[levelName].arenas;//this comes from mods
					if (customTracks) {
						if (tracks && tracks !== 'undefined') {				
							let arenas = customTracks.main.arena.listg
							arenas.forEach((value,key) => {
								let foundTrack = tracks.main.arena.listg[tracks.main.arena.listg.findIndex((x) => x.name === value)];
								if (!foundTrack && foundTrack !== 'undefined'){
									tracks.main.arena.listg.push(arenas[key]);
								}
							})
						}else{
							tracks = customTracks[levelName];
						}
					}
				}
			}
			if (!tracks || tracks === 'undefined') {
				tracks = tracksList.common;
			}
			cards[menuName].listg = tracks.main.arena.listg;
			let trackName = tracks.main.arena.listg[tracks.main.arena.listg.findIndex((x) => x.name === cards[menuName].selected)];//search the saved track to load it
			if (!trackName || cards[menuName].selected === 'Custom' ) {
				cards[menuName].selected =  tracks.main.arena.default.name;
				cards[menuName].type = tracks.main.arena.default.type;
				if (cards[menuName].selected === 'Custom'){
					cards[menuName].url = 'modules/gdcommon/gdImages/noimage.jpg';
				}else{
					cards[menuName].url = tracks.main.arena.default.url;
				}
			}
				cards[menuName].laps = tracks.main.arena.laps.default;
				if(!cards[menuName].laps){
					cards[menuName].laps = 1;
				}
				savedMenu.selected = cards[menuName].selected;
				savedMenu.type = cards[menuName].type;
				savedMenu.url = cards[menuName].url;
				LocalStorage.setObject('laps', cards[menuName].laps);
			}	
			if (menuName === 'vehicles') {
				//type is the Model Group Selected = All Models , burnside, 
				let config2 = cards['config2'].selected;
				let classes = cards['classes'].selected;
				let mods = cards['mods'].selected;
				
				if (!cards[menuName][oppKey]) {
					cards[menuName][oppKey] = {};
					cards[menuName][oppKey].config2 = angular.copy(config2);
					cards[menuName][oppKey].classes = angular.copy(classes);
					cards[menuName][oppKey].mods = angular.copy(mods);
				}
				if (!cards[menuName].selected) {
					cards[menuName].type = cards[menuName].default.type;
					cards[menuName].selected = cards[menuName].default.name;
					cards[menuName].url = cards[menuName].default.url;
				}
				cards[menuName].groups = vconfig.group  //model groups
				let modelGroup = cards[menuName].groups[cards[menuName].groups.findIndex((x) => x === cards[menuName].type)];//search the saved track to load it
				
				if (!modelGroup || cards[menuName][oppKey].config2 !== config2 || cards[menuName][oppKey].classes !== classes || cards[menuName][oppKey].mods !== mods) {
					if (cards[menuName].groups[0] === 'No Vehicles Found --Defaults Listed--'){
						cards[menuName].type = cards[menuName].groups[0];
					}else{
						cards[menuName].type = cards[menuName].default.type;
					}
					console.log('model group not found reset to default')
					cards[menuName].selected = cards[menuName].default.name;
					cards[menuName].url = cards[menuName].default.url;
				}
				cards[menuName].listg = [];
				vconfig.model.forEach((value,key) => {
					if (value.config2 === config2 || value.config2 === 'All Config Groups' || config2 === 'All Config Groups') {   //example config2 = GD-Basic Class
						if (cards[menuName].type === value.type || cards[menuName].type === 'All Models' || cards[menuName].type === 'No Vehicles Found --Defaults Listed--'){
							cards[menuName].listg.push(value);
						}
						
					}
				})
				let indexFound = cards[menuName].listg[cards[menuName].listg.findIndex(x => x.name === savedMenu.selected )];
				if (!indexFound){
				cards[menuName].selected = 'Auto Select'
				}
				if (!cards[menuName].listg.length){
					vconfig.model.forEach((value,key) => {
						if (value.config2 === config2 || value.config2 === 'All Config Groups' || config2 === 'All Config Groups') {   //example config2 = GD-Basic Class
							cards[menuName].listg.push(value);
						}
					})
					cards[menuName].selected = 'Auto Select - None Found'
				}
				if(!cards[menuName].url){
					cards[menuName].url = 'modules/gdcommon/gdImages/noimage.jpg';
				}
				cards[menuName][oppKey].config2 = angular.copy(config2);
				cards[menuName][oppKey].classes = angular.copy(classes);
				cards[menuName][oppKey].mods = angular.copy(mods);
				savedMenu.selected = cards[menuName].selected;  
				savedMenu.type = cards[menuName].type;  //Model Selected
				savedMenu.url = cards[menuName].url;
			}
				
			
			if (oppKey && oppKey > 0){
				if (menuName == 'vehicles' || menuName == 'config2' || menuName == 'mods' || menuName == 'classes'){
					LocalStorage.setObject(oppKey + menuName,savedMenu);
				}
			}else{
				LocalStorage.setObject(menuName,savedMenu);
			}
			//console.log(cards)
			
	}
	function setCards(oldCard){
		cards = angular.copy(oldCard);
		//console.log(cards)
		//console.log('setCards')
	}
	function clearCards(){
		cards = {};
	}
	init();
	return{
		setup:setup,
		init: init,
		setCards: setCards,
		getCards: function ()   {return cards;},
		getOpponents: function () {return opponents;},
		clearCards: clearCards,
	};
		
}]);
/**
 * @ngdoc controller
 * @name beamng.stuff:gdStartController
 * @description Controller for the view that appears on scenario start
**/
app.controller('gdStartController', ['$q','LocalStorage','gdMenuService', 'gdCardService', '$scope', '$state', '$timeout', '$rootScope', 'ControlsUtils', 'Utils', '$ocLazyLoad', 'gamepadNav', '$sce', '$translate', 'VehicleSelectConfig', '$stateParams', 'gdSelectionsService', '$filter', 'translateService',
function ($q,LocalStorage,gdMenuService, gdCardService, $scope, $state, $timeout, $rootScope, ControlsUtils, Utils, $ocLazyLoad, gamepadNav, $sce, $translate, VehicleSelectConfig, $stateParams, gdSelectionsService, $filter, translateService ) {
	'use strict';
	var vm = this;
	
	//console.log('gdStartController reset vm.cards')
	vm.data = null;
	vm.config = { playerValid: true };
	vm.cards = [];
	vm.settings = {};
	let syncplayer = true;

	var crossfireEnabled = gamepadNav.crossfireEnabled()
  var gamepadNavEnabled = gamepadNav.gamepadNavEnabled()
  gamepadNav.enableCrossfire(true)
  gamepadNav.enableGamepadNav(false)
  $scope.$parent.app.stickyPlayState = 'scenario-gdstart'
	var cancelWaiting = Utils.waitForCefAndAngular(() => {
    // Start listening to the controls. Needed for starting the scenario without clicking
    // on the button (e.g. by throttle action)
    bngApi.engineLua('WinInput.setForwardRawEvents(true);')
    bngApi.engineLua('WinInput.setForwardFilteredEvents(true);')

    bngApi.engineLua('extensions.hook("onScenarioUIReady", "start")')
  })

	
	var menuSettings = null;
	
	
	if (!menuSettings){
		menuSettings = gdMenuService.getSettings();
		
	}
	
	
	function setupCards (resetCard, configs, oppKey){
			//adds more opponents to the menu
		gdCardService.clearCards();
		if (resetCard && resetCard.oppKey){
			oppKey = resetCard.oppKey;
		}
		//console.log(oppKey + ' setupCards oppKey')
		if (vm.cards[oppKey]) {
			gdCardService.setCards(vm.cards[oppKey])
		}else{
			if (!vm.cards[oppKey] && oppKey != 0){
				gdCardService.setCards(vm.cards[0])
			}
		}
		let trackMenu = menuSettings.tracks.arenas;
			Object.keys(menuSettings.menu.main).forEach(function (key){
				let menu = menuSettings.menu.main[key];
				if (menu) {
					let vconfigs = null;
					if (configs && configs[menu.alt]){
						vconfigs = configs[menu.alt];
					}
					if(!resetCard || !Array.isArray(resetCard.tables)){
							
								if (oppKey) { 
									//gdCardService.setCards(vm.cards[oppKey])
								}else{
									//gdCardService.setCards(vm.cards[0])
								}
						gdCardService.setup(menu, trackMenu, vconfigs, oppKey);	// menu = classes:Large Cars
					}else{
						Object.keys(resetCard.tables).forEach(function (id){
							//console.log(resetCard.tables[id])
							if (menu.alt === resetCard.tables[id]){
								
								gdCardService.setup(menu, trackMenu, vconfigs, oppKey);	
							}
						});
					}
				}
			})
	}

	vm.gdOppReset = function (roption) {
		//console.log('gdOppReset')
		if (vm.cards[0]) {
			let count = vm.cards[0].opponents.selected.match(/\d+/)[0]  || 3
			
			for(var i=0;i<count;i++) {
				let oppKey = i + 1
				let player = {name: "Player Type", selected:"Computer(AI)", url:"modules/gdcommon/gdImages/player/Computer(AI).jpg", alt:"player", default:"AI", col:3,row:2, show: true, tooltip:"If this vehicle will be computer controlled or human controlled",listng:["Computer(AI)", "Human(MultiSeat)"]};
				let playerSelect = LocalStorage.getObject(oppKey + 'player');
				if (playerSelect) {
					if (playerSelect === 'Human(MultiSeat)'){
						player.url = "modules/gdcommon/gdImages/player/Human(MultiSeat).jpg"
					}
					player.selected = playerSelect
				}
				
				//all - sync with menu default  syncplayer - syncs with the player on startup and changes to player syncap - sync all opponents to player 
				if (!vm.cards[oppKey] || roption === 'syncplayer' || roption === 'all' || roption === oppKey || roption === 'syncap' || roption === (oppKey.toString() + 'syncop')){
					if (roption === 'all'|| roption === oppKey || roption === 'syncap' || roption === (oppKey.toString() + 'syncop') ){
					
						Object.keys(vm.cards[oppKey]).forEach(function (id){
							if (roption === 'syncap' || roption === (oppKey.toString() + 'syncop')){
								let savedMenu = LocalStorage.getObject(id);
								LocalStorage.setObject(oppKey + id, savedMenu);
							}		
							if (roption === oppKey || roption === 'all') {
								LocalStorage.remove(oppKey + id)
							}									
						})
					}
					
					if (roption === 'syncap' || roption === (oppKey.toString() + 'syncop' )){
							gdMenuService.setConfigs();
							gdMenuService.getConfigs().then(function(newconfigs){
								//reset the card to what the player is
								setupCards(null, newconfigs, 0);
								let card = gdCardService.getCards();
								let oppCards = {classes: card['classes'], mods: card['mods'], config2: card['config2'], vehicles: card['vehicles'], player: player};
								vm.cards[oppKey] = angular.copy(oppCards);
								LocalStorage.setObject(oppKey + 'player', player.selected);
							})
					}else{
						if (roption === 'syncplayer' || roption === (oppKey.toString() + 'syncplayer')  ){
							Object.keys(vm.cards[0]).forEach(function (id){
								if (id === 'classes' || id === 'mods' || id === 'config2'){
									let savedMenu = LocalStorage.getObject(id);
									LocalStorage.setObject(oppKey + id, savedMenu);	
									LocalStorage.setObject(oppKey + 'vehicles', 'Auto Select');
								}								
							})
						}
						
						gdMenuService.setConfigs(oppKey);
						gdMenuService.getConfigs().then(function(newconfigs){
							setupCards(null, newconfigs, oppKey);
							let card = gdCardService.getCards();
							let oppCards = {classes: card['classes'], mods: card['mods'], config2: card['config2'], vehicles: card['vehicles'], player: player};
							vm.cards[oppKey] = angular.copy(oppCards);
							LocalStorage.setObject(oppKey + 'player', player.selected);
						})
					}
					
				}
			}
				
			let overCount = (Object.keys(vm.cards).length - 1) - count;
			if (overCount > 0) {
				for(var i=0;i<overCount;i++) {
					let Index = Object.keys(vm.cards).length  
					delete vm.cards[Index - 1]; 
				}
			}
			//console.log(vm.cards)
		}else{
			$scope.$emit('gdConfig');
		};
	};
	
	function gdConfigResponse (resetCard){
		//console.log('gdConfigResponse ')
		//console.log(resetCard)
		
		gdMenuService.getConfigs().then(function(configs){
		
			
			setupCards(resetCard, configs, 0);
			
			let card = gdCardService.getCards();
			if (!vm.cards[0] ) {
				//console.log(card)
				//console.log('gdConfigRepsonse vmcards 0')
				vm.cards[0] = angular.copy(card);
				if (syncplayer === true){
					vm.gdOppReset('syncplayer');
				}else{	
					vm.gdOppReset('na');
				}
			}
			if (resetCard && resetCard.tables) {
				Object.keys(resetCard.tables).forEach(function (id){
					let cardName = resetCard.tables[id];   //vehicles cardname
					if (resetCard.oppKey) {
						vm.cards[resetCard.oppKey][cardName] = angular.copy(card[cardName]);
					}else{
						vm.cards[0][cardName] = angular.copy(card[cardName]);
						if (syncplayer === true){
							//console.log(syncplayer + ' Sync Player')
							vm.gdOppReset('syncplayer');
						}
					}
				})
			}
		
			//gdMenuService.saveMenus();
			//console.log(configs);
			//console.log(vm.cards);
		
		})
	}
	
	function gdConfigList (resetCard) {
			//console.log('gdConfigList')
			if (menuSettings && menuSettings.menu && menuSettings.menu.settings){
				Object.keys(menuSettings.menu.settings).forEach(function (key){
					let options = menuSettings.menu.settings[key];
					let savedOptions = LocalStorage.getObject(key);
					if (savedOptions || typeof savedOptions == "boolean"){
						options.selected = savedOptions;
					}else{
						options.selected = options.default;
					}
					LocalStorage.setObject(key, options.selected);
					vm.settings[key] = options;
					if (key === 'syncplayer'){
						syncplayer = savedOptions;
					}
				})	
			}else{
				menuSettings = gdMenuService.getSettings();
				
			}
			//this will add vehicles to the opponents tab if they change the number of vehicles in the menu
			if (resetCard && resetCard.tables && resetCard.tables[0] === 'vehCount'){  
				if (syncplayer === true){
					let count = vm.cards[0].opponents.selected.match(/\d+/)[0]  || 3
					vm.gdOppReset(count.toString() + 'syncplayer');
				}else{	
					vm.gdOppReset('na');
				}
			}else{
				gdMenuService.setConfigs();
				gdConfigResponse(resetCard);
			}
			
			
			
			
	}
		
	
	$scope.$on('gdConfig', function(event, resetCard){
		gdConfigList(resetCard);
	});
	
	gdConfigList();
	
	
	//parts 
	vm.clear = function(menu){
		LocalStorage.remove(menu,'parts')
		vm.selected.parts[menu] = {}
	};
   vm.section = function(index) {
      var acc = document.getElementsByClassName('accordion')
      acc[index].classList.toggle("active");
      acc[index].nextElementSibling.classList.toggle("show");
    };
	
	
	
	
	vm.getPreview = function (name) {
		var menu = name.toLowerCase();
			if (menuSaved[menu] !== 'undefinded')
			{
				var img = 'modules/gdcommon/gdImages/' + menu + '/' + menuSaved[menu] + '.jpg';
				if (menu === 'map'){
					var level
					level = levelData[levelData.findIndex((x) => x.levelName === menuSaved[menu])];
					if(level && level.name ) {
						if(level.previews.length > 0) {
							img = level.previews 
							//level.previews[Math.floor(Math.random() * level.previews.length)];
							gdSelectionsService.setLevel({
								name: level.name,
								preview: img,
								file: level,
								targetState: 'gdMapSelect'
							});
						}
					}
				};
				return img;
			}
	};

	vm.setState = function (name) {
		if (state !== 'undefined'){
			state = 'gd' + state + 'Select'
			if (state === 'scenario-start'){
				return;
			}
			$state.go(state);
		}
	};
	
	//vm.isDisabled = function () {
		//return !vm.selections.level.file || !vm.selections.track.file || !vm.selections.vehicle.file;
	//};
	
	
	//vm.selectLevel = function(vm.selected, gameState, goToTrack) {
	 //var preview = null;
    //if(scenario.previews.length > 0) {
     // preview = scenario.previews[Math.floor(Math.random() * scenario.previews.length)];
    //}
    //gdSelectionsService.setLevel({
      //name: scenario.name,
     // preview: preview,
     // file:scenario,
     // targetState:'gdLevelSelect',
    //});
	//}
	
	//example card is selections.level targetState is gdLevelSelect
	
  // Run on launch ----------------------------------------------------------------

  // This is actually a request to the Lua engine to send a "ScenarioChange"
  // event through the HookManager, with information about the about-to-start scenario.
  // A listener is already registered.

  //var cancelWaiting = Utils.waitForCefAndAngular(() => {
   // $scope.$emit('ShowApps', false);
   // bngApi.engineLua("extensions.core_input_bindings.menuActive(true);");
    // Start listening to the controls. Needed for starting the scenario without clicking
    // on the button (e.g. by throttle action)
   // bngApi.engineLua('WinInput.setForwardRawEvents(true);');
    //bngApi.engineLua('WinInput.setForwardFilteredEvents(true);');

   // $scope.$emit('StickyState', $state.$current.name)

   // bngApi.engineLua('extensions.hook("onScenarioUIReady", "start")')
  //});

	
  /*
   * @ngdoc method
   * @name beamng.stuff:ScenarioStartController#play
   * @methodOf beamng.stuff:ScenarioGdstartController
   *
   * @description Informs Lua that we are ready to launch the loaded scenario
   */
   
    vm.startScenario = function() {
		//gdMenuService.saveMenus();
		//let vconfigs = [];
		
		let vconfigs = angular.copy(vm.cards[0].vehicles.listg)
		//angular.forEach(vm.cards, function(value, key) {
		//	console.log(vm.cards[key].vehicles.listg)
		//	vconfigs[key] = angular.copy(vm.cards[key].vehicles.listg)
		//});
		
		gdMenuService.saveConfigs(vconfigs);
		  vm.play();
		  //$scope.$emit('ShowApps', true);
  }
   vm.play = function () {
	   $scope.$parent.app.stickyPlayState = null
	 var luaCmd = 'scenario_gdscenariosLoader.scenarioStart()'
	
		bngApi.engineLua(luaCmd)
		$state.go('play')
  }
  
  vm.getIconName = function (devName) { return ControlsUtils.deviceIcon(devName); };


 


  // We no longer need to listen to the controls once the state is gone.
  $scope.$on('$destroy', function() {
	console.log('distory contoller gd');
     cancelWaiting()
	 $state.go('play')
    bngApi.engineLua('WinInput.setForwardRawEvents(false);')
    bngApi.engineLua('WinInput.setForwardFilteredEvents(false);')
    gamepadNav.enableCrossfire(crossfireEnabled); // use old value from before opening the menu here
    gamepadNav.enableGamepadNav(gamepadNavEnabled); // use old value here
  });
}]);

app.controller('gdEndController', ['translateService','$scope', '$state', '$stateParams', '$timeout', '$filter', 'gamepadNav',
function (translateService, $scope,  $state, $stateParams, $timeout, $filter, gamepadNav) {
	var crossfireEnabled = gamepadNav.crossfireEnabled()
  var gamepadNavEnabled = gamepadNav.gamepadNavEnabled()
  gamepadNav.enableCrossfire(true)
  gamepadNav.enableGamepadNav(false)

  $scope.$parent.app.stickyPlayState = 'gdscenario-end'

  var data = $stateParams.endData;
  
  // debugger;
	if (data.options === undefined){
		 bngApi.engineLua("gdscenarios.endScreen();");
		 return
	}
 
	 
	var title = data.options.map + ' - ' + data.options.tracks.selected;
	
	//remove _ in titles
	$scope.eventTitle = title.replace(/_/g, ' ');
	
	$scope.drivers = $stateParams.drivers;
	$scope.headers = $stateParams.headers;
	
	$scope.filter = function(value, filter) {
   if(filter)
    {
      return $filter(filter)(value);
    }{
      
      return value
      }
  };
	// column to sort
	$scope.column = 'place';
	 
	 // sort ordering (Ascending or Descending). Set true for desending
	$scope.reverse = false; 
	
	// called on header click
	$scope.sortColumn = function(col){
	$scope.column = col;
	if($scope.reverse){
		$scope.reverse = false;
		$scope.reverseclass = 'arrow-up';
	}else{
		$scope.reverse = true;
		$scope.reverseclass = 'arrow-down';
		}
	};
	
	// remove and change class
	$scope.sortClass = function(col){
	if($scope.column == col ){
		if($scope.reverse){
			return 'arrow-down'; 
		}else{
			return 'arrow-up';
		}
	}else{
		return '';
	}
	}; 
 
	if(data.buttons != null) {
    for(var i = 0; i<data.buttons.length ; i=i+1) {
      data.buttons[i].label = translateService.contextTranslate(data.buttons[i].label)
    }
  }
  $scope.data = data;
 $scope.activeButton = $scope.data.buttons.length - 1

  for (var i = $scope.data.buttons.length - 1; i >= 0; i--) {
    if ($scope.data.buttons[i].active) {
      $scope.activeButton = i
    }
  }

  var cmds = {
    openMenu: function () {
      $scope.$emit('MenuToggle', true)
    },
     openScenarios:function(){
      //$scope.$emit('MenuToggle', true)
      setTimeout(function() {$state.go('menu.scenarios');})
    },
  };

  function execHelper (cmd) {
    var luaCmd = cmds[cmd] === undefined
    return {
      func: luaCmd ? () =>{$state.go('play'); bngApi.engineLua(cmd)} : cmds[cmd],
      exits: luaCmd
    }
  }

  $scope.executeCmd = function (cmdStr, showLoadingScreen) {
    console.log(cmdStr)
    var cmd = execHelper(cmdStr)
    $scope.$parent.app.stickyPlayState = null
    cmd.func()
  }

  $scope.getBarSound = function (i) {
    if (i === 0) {
      return {animationstart: 'event:>UI>Scenario End Counting'};
    }
    return {};
  };


   $scope.$on('$destroy', () => {
    gamepadNav.enableCrossfire(crossfireEnabled); // use old value from before opening the menu here
    gamepadNav.enableGamepadNav(gamepadNavEnabled); // use old value here
  })

}]);
app.controller('gdLevelController', ['$filter', 'gdSelectionsService', '$scope', '$state', '$interval', 'Aux',
  function($filter, gdSelectionsService, $scope, $state, $interval, Aux) {
var vm = this;
  var res = gdSelectionsService.getSelections();
  vm.selected = res.level;
  vm.filtered = res.levels;

console.log(res);
 // bngApi.engineLua('gdcallback.getgdLevelList()', function(res) {
   // showList(res);
 // });


  function showList(res) {
    $scope.$evalAsync(() => {
     vm.selected = res.level;
      vm.filtered = res.levels;
    });
  }



  // TODO: select the first entry of the filtered list always
  var selectedTimer = 0;//Timer to make previews one by one in a certain duration


  function changePreview() {
    vm.selected.preImgIndex++;
    if (vm.selected.preImgIndex > vm.selected.previews.length - 1) {
      vm.selected.preImgIndex = 0;
    }
    vm.selected.preview = vm.selected.previews[vm.selected.preImgIndex];
  }

  vm.selectLevel = function(level) {
    console.log('selectLevel function');
	$interval.cancel(selectedTimer);
	vm.selected = level;
    if (!vm.selected.previews) {
      vm.selected.preview = null;
      return;
    }
    vm.selected.preview = vm.selected.previews[vm.selected.preImgIndex];
    if (vm.selected.previews.length > 1) {
      selectedTimer = $interval(changePreview, 3000);
    }
  };

  vm.startLevel = function(scenario, gameState, goToTrack) {
    //scenario.raceFile = "quickrace/skycurve1"
    //var luaCmd = 'scenario_scenarios.start(' + bngApi.serializeToLua(scenario) + ')';
    //bngApi.engineLua(luaCmd);
	console.log('startlevel function');
    var preview = null;
    if(scenario.previews.length > 0) {
      preview = scenario.previews[Math.floor(Math.random() * scenario.previews.length)];
    }
    gdSelectionsService.setLevel({
      name: scenario.name,
      preview: preview,
      file:scenario,
      targetState:'gdLevelSelect',
    });
    gdSelectionsService.setTrack({
      name: 'Select Arena or Track',
      file: null,
     targetState:'gdTrackSelect',
     preview: '/ui/images/appDefault.png'
    });
    if(goToTrack) {
      $state.go(`^.gdTrackselect`);
    } else {
      $state.go(`^.gdLevelSelect`);
    }
  };
}]);

app.controller('gdTrackController', ['$filter', 'gdSelectionsService', '$scope', '$state', '$interval', 'Aux', 'VehicleSelectConfig',
  function($filter, gdSelectionsService, $scope, $state, $interval, Aux, VehicleSelectConfig) {

  var levelName = gdSelectionsService.getSelections().level.name;
  var available = [];
  $scope.filtered = [];
  $scope.selected = null;
  $scope.query = '';

  $scope.tilesOrder = [
    {label: 'Difficulty', key: 'difficulty'},
    {label: 'Date',       key: '-date'},
    {label: 'Author',     key: 'authors'},
    {label: 'Players',    key: '-maxPlayers'},
  ];

  $scope.selectedOrder = $scope.tilesOrder[0].key;


  bngApi.engineLua("", function(res) {
    available = [];
    showList(gdSelectionsService.getSelections().level.file.tracks)
  });


  function showList(res) {
    $scope.filtered = [];

    for (var i = 0; i < res.length; i++) {
      if (res[i].previews && res[i].previews.length > 0) {
        res[i].preview = res[i].previews[0];

        if (res[i].reversePreviews && res[i].reversePreviews.length > 0)
          res[i].reversePreview = res[i].reversePreviews[0];
        else
          res[i].reversePreview = null;
        res[i].preImgIndex = 0;
        res[i].maxPlayers = 0;

        for (var j in res[i].vehicles) {
            var v = res[i].vehicles[j];
            if (v.playerUsable == true) res[i].maxPlayers++;
            if (v.driver && v.driver.player == true) res[i].maxPlayers++;
        }
        if (res[i].playersCountRange) res[i].maxPlayers = res[i].playersCountRange.max;
        res[i].minPlayers = res[i].maxPlayers;
        if (res[i].playersCountRange) res[i].minPlayers = res[i].playersCountRange.min;
      }

    }

    available = res;

    $scope.$watchGroup(['query', 'selectedOrder'], function (value) {
      var temp = $filter('filter')(available, value[0]);
      temp = $filter('orderBy')(temp, [value[1], 'name']);
      $scope.filtered = temp;
      $scope.selected = $scope.filtered[0];
    });

    $scope.$digest(); // trigger the $watchGroup
  }



  // TODO: select the first entry of the filtered list always
  var selectedTimer = 0;//Timer to make previews one by one in a certain duration


  function changePreview() {
    $scope.selected.preImgIndex++;
    if ($scope.selected.preImgIndex > $scope.selected.previews.length - 1) {
      $scope.selected.preImgIndex = 0;
    }
    $scope.selected.preview = $scope.selected.previews[$scope.selected.preImgIndex];
  }

  $scope.difText = function (num) {
    var val = ['ui.scenarios.difficulty.easy', 'ui.scenarios.difficulty.medium', 'ui.scenarios.difficulty.hard', 'ui.scenarios.difficulty.veryHard'];
    return val[Math.floor(parseFloat(num)/25)];
  }

  $scope.openRepo = function () {
    //window.location.href = 'http-external://www.beamng.com/resources/categories/scenario_scenarios.8/?ingame=2';
  };

  $scope.selectTrack = function(level) {
    //console.log(level);
    $interval.cancel(selectedTimer);
    $scope.selected = level;
    if (!$scope.selected.previews) {
      $scope.selected.preview = null;
      return;
    }
    $scope.selected.preview = $scope.selected.previews[$scope.selected.preImgIndex];
    if ($scope.selected.previews.length > 1) {
      selectedTimer = $interval(changePreview, 3000);
    }
  };

  $scope.startTrack = function(track, gameState, goToVehicles) {
    //scenario.raceFile = "quickrace/skycurve1"
    //var luaCmd = 'scenario_scenarios.start(' + bngApi.serializeToLua(scenario) + ')';
    //bngApi.engineLua(luaCmd);
   // bngApi.engineLua("dump(" + bngApi.serializeToLua(track) + ")");

    if (track.reversible) {
      track.reverse = false; // init this
    }

    if (track.allowRollingStart) {
      track.rollingStart = false; // and this
    }

    QuickraceService.setTrack({
      name: track.name,
      file: track,
      preview: track.preview,
      reversePreview: track.reversePreview,
      targetState:'quickraceTrackselect'
    });
    if(goToVehicles && QuickraceService.getSelections().vehicle.model == null) {
      VehicleSelectConfig.configs['quickrace'].backButtonRef = '^.quickraceTrackselect';
      $state.go(`menu.vehicles`, {mode: 'quickrace'});
    } else {
      VehicleSelectConfig.configs['quickrace'].backButtonRef = '^.quickraceOverview';
      $state.go(`^.quickraceOverview`);
    }
     //$state.go(`^.quickraceOverview`);
  };
}])

;